// --- [ USI_Slave_e.h ] ----------------------------------------------------
//
//       tab = 3, 20.12.2013
//
// This file has been prepared for Doxygen automatic documentation generation.
/*! \file ********************************************************************
*
* Atmel Corporation  ### NDERUNGEN AM ORIGINAL VORGENOMMEN ###
*
* File              : USI_USI_Slave_b.h
* Compiler          : IAR EWAAVR 4.11A
* Revision          : $Revision: 1.14 $
* Date              : $Date: Friday, December 09, 2005 17:25:38 UTC $
* Updated by        : $Author: jtyssoe $
*
* Support mail      : avr@atmel.com
*
* Supported devices : All device with USI module can be used.
*                     The example is written for the ATmega169, ATtiny26 & ATtiny2313
*
* AppNote           : AVR312 - Using the USI module as a TWI slave
*
* Description       : Header file for USI_TWI driver
*
* NDERUNG: zustzlicher USI_state eingebaut
* ermglicht Abfrage von aussen, ob eine bertragung abgeschlossen ist
*
****************************************************************************/
//! Prototypes


void    USI_SLA_Init( void );
void    USI_SLA_Put_Data(uint8_t * data, uint8_t cnt);
void    USI_SLA_Get_Data(uint8_t * data);
uint8_t USI_SLA_Rx_Cnt(void);
uint8_t USI_SLA_Received_Bytes( void );
void    USI_SLA_Set_TxPtr(uint8_t * data);
void    USI_Write_TWI_Adr(uint8_t * data);
//uint8_t USI_SLA_Busy( void );


//////////////////////////////////////////////////////////////////
///////////////// Driver Buffer Definitions //////////////////////
//////////////////////////////////////////////////////////////////
// 1,2,4,8,16,32,64,128 or 256 bytes are allowed buffer sizes

#define USI_RX_BUFFER_SIZE  (8)
#define USI_RX_BUFFER_MASK ( USI_RX_BUFFER_SIZE - 1 )

#if ( USI_RX_BUFFER_SIZE & USI_RX_BUFFER_MASK )
        #error TWI RX buffer size is not a power of 2
#endif

// 1,2,4,8,16,32,64,128 or 256 bytes are allowed buffer sizes

#define USI_TX_BUFFER_SIZE  (32)
#define USI_TX_BUFFER_MASK ( USI_TX_BUFFER_SIZE - 1 )

#if ( USI_TX_BUFFER_SIZE & USI_TX_BUFFER_MASK )
        #error TWI TX buffer size is not a power of 2
#endif


// der Status mit dem Wert 0 ist ergnzt = !busy
#define USI_SLAVE_WAITING							  (0x00)  // neue Zeile
#define USI_SLAVE_CHECK_ADDRESS                (0x01)  // NDERUNG
#define USI_SLAVE_SEND_DATA                    (0x02)  // NDERUNG
#define USI_SLAVE_REQUEST_REPLY_FROM_SEND_DATA (0x04)  // NDERUNG
#define USI_SLAVE_CHECK_REPLY_FROM_SEND_DATA   (0x08)  // NDERUNG
#define USI_SLAVE_REQUEST_DATA                 (0x10)  // NDERUNG
#define USI_SLAVE_GET_DATA_AND_SEND_ACK        (0x20)  // NDERUNG


// --- Device dependent defines -----------------------------------------------

/*
// --- attiny 25/45/85 --------------------------------------------------------
#define DDR_USI             DDRB
#define PORT_USI            PORTB
#define PIN_USI             PINB
#define PORT_USI_SDA        PB0
#define PORT_USI_SCL        PB2
#define PIN_USI_SDA         PB0
#define PIN_USI_SCL         PB2
#define USI_START_COND_INT  USISIF
#define USI_START_VECTOR    USI_START_vect
#define USI_OVERFLOW_VECTOR USI_OVF_vect
*/



// --- attiny 24/44/84 --------------------------------------------------------
#define DDR_USI             DDRA
#define PORT_USI            PORTA
#define PIN_USI             PINA
#define PORT_USI_SDA        PA6
#define PORT_USI_SCL        PA4
#define PIN_USI_SDA         PA6
#define PIN_USI_SCL         PA4
#define USI_START_COND_INT  USISIF
#define USI_START_VECTOR    USI_START_vect
#define USI_OVERFLOW_VECTOR USI_OVF_vect

/*
//! Device dependent defines
#if defined(__AT90tiny26__) | defined(attiny26)
    #define DDR_USI             DDRB
    #define PORT_USI            PORTB
    #define PIN_USI             PINB
    #define PORT_USI_SDA        PORTB0
    #define PORT_USI_SCL        PORTB2
    #define PIN_USI_SDA         PINB0
    #define PIN_USI_SCL         PINB2
    #define USI_START_COND_INT  USISIF
    #define USI_START_VECTOR    USI_STRT_vect
    #define USI_OVERFLOW_VECTOR USI_OVF_vect
#endif
*/
/*
#if defined(__AT90Tiny2313__) | defined(_AVR_IOTN2313_H_)
    #define DDR_USI             DDRB
    #define PORT_USI            PORTB
    #define PIN_USI             PINB
    #define PORT_USI_SDA        PORTB5
    #define PORT_USI_SCL        PORTB7
    #define PIN_USI_SDA         PINB5
    #define PIN_USI_SCL         PINB7
    #define USI_START_COND_INT  USISIF
    #define USI_START_VECTOR    USI_START_vect
    #define USI_OVERFLOW_VECTOR USI_OVERFLOW_vect
#endif
*/

/*
//#if defined(__ATtiny25__) | defined(__ATtiny45__) | defined(__ATtiny85__)
    #define DDR_USI             DDRB
    #define PORT_USI            PORTB
    #define PIN_USI             PINB
    #define PORT_USI_SDA        PORTB0
    #define PORT_USI_SCL        PORTB2
    #define PIN_USI_SDA         PINB0
    #define PIN_USI_SCL         PINB2
    #define USI_START_COND_INT  USISIF
    #define USI_START_VECTOR    USI_START_vect
    #define USI_OVERFLOW_VECTOR USI_OVF_vect
//#endif
*/
/*
#if defined(__AT90Mega165__) | defined(__ATmega165__) | \
    defined(__ATmega325__) | defined(__ATmega3250__) | \
    defined(__ATmega645__) | defined(__ATmega6450__) | \
    defined(__ATmega329__) | defined(__ATmega3290__) | \
    defined(__ATmega649__) | defined(__ATmega6490__)
    #define DDR_USI             DDRE
    #define PORT_USI            PORTE
    #define PIN_USI             PINE
    #define PORT_USI_SDA        PORTE5
    #define PORT_USI_SCL        PORTE4
    #define PIN_USI_SDA         PINE5
    #define PIN_USI_SCL         PINE4
    #define USI_START_COND_INT  USISIF
    #define USI_START_VECTOR    USI_START_vect
    #define USI_OVERFLOW_VECTOR USI_OVERFLOW_vect
#endif

#if defined(__AT90Mega169__) | defined(__ATmega169__)
    #define DDR_USI             DDRE
    #define PORT_USI            PORTE
    #define PIN_USI             PINE
    #define PORT_USI_SDA        PORTE5
    #define PORT_USI_SCL        PORTE4
    #define PIN_USI_SDA         PINE5
    #define PIN_USI_SCL         PINE4
    #define USI_START_COND_INT  USISIF
    #define USI_START_VECTOR    USI_STRT_vect
    #define USI_OVERFLOW_VECTOR USI_OVF_vect
#endif
*/

// --- Functions implemented as macros ----------------------------------------

#define SET_USI_TO_SEND_ACK()                                                                            \
{                                                                                                        \
   USIDR    =  0;                                              /* Prepare ACK                         */ \
   DDR_USI |=  (1<<PORT_USI_SDA);                              /* Set SDA as output                   */ \
   USISR    =  (0<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|  /* Clear all flags, except Start Cond  */ \
               (0x0E<<USICNT0);                                /* set USI counter to shift 1 bit.     */ \
}

#define SET_USI_TO_READ_ACK()                                                                            \
{                                                                                                        \
   DDR_USI &=  ~(1<<PORT_USI_SDA);                             /* Set SDA as input */                    \
   USIDR    =  0;                                              /* Prepare ACK        */                  \
   USISR   	=  (0<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|  /* Clear all flags, except Start Cond  */ \
               (0x0E<<USICNT0);                                /* set USI counter to shift 1 bit. */ \
}

#define SET_USI_TO_USI_START_CONDITION_MODE()                                                                         \
{                                                                                                                     \
	USICR =  (1<<USISIE)|(0<<USIOIE)|               /* Enable Start Condition Interrupt. Disable Overflow Interrupt.*/ \
				(1<<USIWM1)|(0<<USIWM0)|               /* Set USI in Two-wire mode. No USI Counter overflow hold.      */ \
				(1<<USICS1)|(0<<USICS0)|(0<<USICLK)|   /* Shift Register Clock Source = External, positive edge        */ \
				(0<<USITC);                                                                                               \
	USISR =  (0<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|  /* Clear all flags, except Start Cond      */ \
				(0x0<<USICNT0);                                                                                           \
}

#define SET_USI_TO_SEND_DATA()                                                                \
{                                                                                             \
   DDR_USI |=  (1<<PORT_USI_SDA);                    /* Set SDA as output                  */ \
   USISR    =  (0<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|      /* Clear all flags, except Start Cond */ \
               (0x0<<USICNT0);                        /* set USI to shift out 8 bits        */ \
}

#define SET_USI_TO_READ_DATA()   																					\
{                                                                                               \
    DDR_USI &= ~(1<<PORT_USI_SDA);                     /* Set SDA as input                   */ \
    USISR    =  (0<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|      /* Clear all flags, except Start Cond */ \
                (0x0<<USICNT0);                        /* set USI to shift out 8 bits        */ \
}

// --- [ eof ] ----------------------------------------------------------------
