// --- [eeprom.c ] ------------------------------------------------------------

#include <avr/io.h>

// ----------------------------------------------------------------------------
// Schreibt ein Byte an die angegebene Adresse
void EE_Write(uint8_t eeprom_adr, uint8_t data)
{
   while (EECR & (1<<EEPE));
   asm volatile("cli");
   EECR = (0<<EEPM1 | 0<<EEPM0);

// EEARH = 0;
   EEARL = eeprom_adr;
	EEDR  = data;					            // Daten schreiben

	EECR |= (1<<EEMPE);
	EECR |= (1<<EEPE);
   asm volatile("sei");
}


// ----------------------------------------------------------------------------
// Liest ein Byte von der angegebenen Adresse
uint8_t EE_Read(uint8_t eeprom_adr)
{
   while (EECR & (1<<EEPE));
   asm volatile("cli");
// EEARH = (uint8_t) (eeprom_adr >> 8);	// Adresse schreiben
//	EEARL = (uint8_t) eeprom_adr;
// EEARH = 0;
   EEARL = eeprom_adr;
	EECR |= (1<<EERE);						   // Eeprom lesen
   asm volatile("sei");
   return (EEDR);
}

// --- [ eof ] ----------------------------------------------------------------
