// --- [ global.h ] ----------------------------------------------------------

#ifndef EXTERN
#define EXTERN extern
#endif

#define TRUE      1
#define FALSE     0

#define FET		   PA1
#define LED_GRN	PA2
#define LED_YEL   PA3
#define LED_ERR   PA5

#define TASTE	   PB2
#define TASTE_INT PCINT10
// ----------------------------  // TIMER1

#define TIMER1_ON       (1<<WGM12 | 1<<CS12 | 0<<CS11 | 0<<CS10);
#define TIMER1_OFF      0

// ----------------------------  // Interrupts in ASM oder C ?

#define IRQ_IN_ASM   FALSE       // FALSE = als C-Code

// ----------------------------  // Teuere 32-Bit  Berechnungen ausfhren ?

#define CALC_I       FALSE       // Den flieenden Strom berechnen, aber das
                                 // kostet etwa 180 Byte Speicherplatz !!
                                 // Ein externes Programm knnte die Formel I = U/R anwenden!

// ----------------------------  // Welche Spannungsreferenz soll verwendet werden ?
                                 // Achtung, es sind dazu die Anschlsse anzupassen !
#define R_INTERN     1
#define R_EXTERN     2
#define REFERENZ     R_EXTERN


// ----------------------------  // Widerstandwerte einlesen / ndern

#define READ_R    FALSE          // wird zur Berechnung nicht genutzt,
                                 // kann daher entfallen

// ----------------------------  // Vor-Einstellungen

#define VREFe	   4375				// externe Referenzspannung im mV
#define VREFi     1100           // interne Referenzspannung (Soll 1100mV)
#define VFIN	   3300				// Entladeschlussspannung / Abschaltspannung im mV
#define R	      100   		   // Lastwiderstand in 1/10tel Ohm !!!
                                 // wird nur verwendet, wenn CALC_I == TRUE

#define TWI_EEPROM_ADR     160
#define EEPROM_WAIT_TIME   50    // Wartezeit zwischen zwei Schreibaktionen in ms

#define INTERVALL_1     6         // jede 6.Sekunde eine Messung ausfhren
#define INTERVALL_2     5         // nach jeder 5. Messung Messwerte ins Eeprom schreiben
                                  // also jeweils nach 30 Sekunden

/*
Via USI-TWI-Slave vornehmbare Einstellungen
Es mssen immer genau 4 Byte gesendet werden, beginnend mit der TWI-Adresse (hier "8")

TWI-Adresse, Byte1, Byte2, Byte3

1.) TWI-Adresse einstellen
8, 251, alte Adresse, neue Adresse

2.) Referenzspannung einstellen
8, 252, U_high, U_low

3.) Entladeschlussspannung einstellen
8, 253, U_high, U_low

4. Entladewiderstand einstellen (in 1/10tel Ohm)
8, 254, R_high, R_low

Die derungen von 1.) bis 4.) werden erst nach einem Reset wirksam,
da sie zunchst lediglich in Tiny-Erprom geschrieben.
Bei jeder nderung wird die rote LED getogglet.

Die nachfolgenden Kommandos werden unmittelbar ausgefhrt.
5.) Entladevorgang starten
8, 100, 200, x

6.) Entladevorgang unterbrechen
8, 201

7. unterbrochenen Entladevorgang fortsetzen
8, 202

8.) Entladung beenden
8, 203


*/
// --- { eof ] ----------------------------------------------------------------
